#ifndef _SAUCER_LOG_H_INCLUDED_
#define _SAUCER_LOG_H_INCLUDED_

typedef struct _User *User;
typedef struct _Genre *Genre;
typedef struct _Question *Question;
typedef struct _Reply *Reply;
typedef struct _Clear *Clear;

User User_Create(char *uid, char *name, Saucer saucer);
User User_Destroy(User user);
char *User_GetUID(User user);
char *User_GetName(User user);
Saucer User_GetSaucer(User user);
Saucer User_SetSaucer(User user, Saucer saucer);

Genre Genre_Create(char *name);
Genre Genre_Destroy(Genre genre);
char *Genre_GetName(Genre genre);
int Genre_GetImageWidth(Genre genre);
int Genre_GetImageHeight(Genre genre);
unsigned char *Genre_GetImage(Genre genre);
ObjList Genre_GetQuestions(Genre genre);

Question Question_Create(char *qid, int score, Genre genre);
Question Question_Destroy(Question question);
char *Question_GetQID(Question question);
int Question_GetScore(Question question);
int Question_GetImageWidth(Question question);
int Question_GetImageHeight(Question question);
unsigned char *Question_GetImage(Question question);
Genre Question_GetGenre(Question question);

Reply Reply_Create(User user, Question question, int t);
Reply Reply_Destroy(Reply reply);
User Reply_GetUser(Reply reply);
Question Reply_GetQuestion(Reply reply);
int Reply_GetTime(Reply reply);

Clear Clear_Create(User user, Question question, int t);
Clear Clear_Destroy(Clear clear);
User Clear_GetUser(Clear clear);
Question Clear_GetQuestion(Clear clear);
int Clear_GetTime(Clear clear);

User User_ListSearch(ObjList list, char *uid);
Genre Genre_ListSearch(ObjList list, char *name);
Question Question_ListSearch(ObjList list, char *qid);
Question Question_ListSearchAll(ObjList list, char *qid);
Reply Reply_ListSearch(ObjList list, User user, Question question);
Clear Clear_ListSearch(ObjList list, User user, Question question);

#endif
